! This file is part of FD4: Four-Dimensional Distributed Dynamic Data structures
!  
! Copyright 2010-2011 Matthias Lieber, ZIH, TU Dresden, Germany
! matthias.lieber@tu-dresden.de
!  
! FD4 is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!  
! FD4 is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!  
! You should have received a copy of the GNU General Public License
! along with FD4.  If not, see <http://www.gnu.org/licenses/>.

!--------------------------------------------------------------!
!                                                              !
!                      Timing Utilities                        !
!                                                              !
!--------------------------------------------------------------!

!! Timing Utilities.
!!
!! @author Matthias Lieber
module timing_mod

  !use kinds_mod
  implicit none
  
  public
  
  !! Get the number of microseconds since the Epoch.
  !!
  !! This is actually a C routine located in $gettimec.$c.
  !! It calls $gettimeofday to retrieve the number of microseconds since the
  !! Epoch (00:00:00 UTC, January 1, 1970).
  !!
  !! *Note*: The parameter $t is a 64 bit integer.
  !!
  interface gettime
    subroutine gettimec(t)
      use kinds_mod, only: i8k
      integer(i8k), intent(out) :: t
    end subroutine gettimec
  end interface gettime
  
end module timing_mod
